## spuce-0.4.3.tar.gz

=== CMakeLists.txt ===
########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 2.8)
project(spuce)
enable_language(CXX)
include(FeatureSummary)
include(CMakeDependentOption)

if (NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE "RELEASE")
endif()

# Shouldn't have to do this
if (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Windows")
	message(STATUS "Adding -std=c++11")
	add_definitions("-std=c++11")
endif()

include_directories("${CMAKE_CURRENT_SOURCE_DIR}")

set(SPUCE_MAJOR_VERSION 0)
set(SPUCE_MINOR_VERSION 4)
set(SPUCE_PATCH_VERSION 3)

SET(SPUCE_LIBVER ${SPUCE_MAJOR_VERSION}.${SPUCE_MINOR_VERSION}.${SPUCE_PATCH_VERSION})
SET(SPUCE_SOVER "${SPUCE_LIBVER}")
set(SPUCE_VERSION "${SPUCE_LIBVER}")

add_subdirectory(spuce)
FIND_PACKAGE(Qt5 COMPONENTS Gui Core Widgets)
if (NOT Qt5_FOUND)
  message(STATUS "QT5 not found - will skip building QT5 Apps")
endif()
cmake_dependent_option(ENABLE_GUI "Enable QT application" ON "Qt5_FOUND" OFF)
add_feature_info(ENABLE_GUI ENABLE_GUI "This enables the QT applications to be built")
if (ENABLE_GUI)
	add_subdirectory(qt_fir)
	add_subdirectory(qt_iir)
	add_subdirectory(qt_window)
	add_subdirectory(qt_other)
endif()
FIND_PACKAGE(PythonLibs)
if (NOT PYTHONLIBS_FOUND)
  message(STATUS "PythonLibs not found - will skip building test programs")
endif()  
cmake_dependent_option(BUILD_TESTING "Enable python based tests" ON "PYTHONLIBS_FOUND" OFF)
add_feature_info(BUILD_TESTING BUILD_TESTING "This enables python testing with matplotlib graphs")
if (BUILD_TESTING)
	add_subdirectory(test_spuce)
endif()



########################################################################
# Install cmake helper modules
########################################################################
configure_file(
    ${PROJECT_SOURCE_DIR}/cmake/SpuceConfigVersion.in.cmake
    ${PROJECT_BINARY_DIR}/SpuceConfigVersion.cmake
@ONLY)
set(cmake_files
    ${PROJECT_SOURCE_DIR}/cmake/SpuceConfig.cmake
    ${PROJECT_BINARY_DIR}/SpuceConfigVersion.cmake)
if (UNIX)
    install(FILES ${cmake_files} DESTINATION share/cmake/${PROJECT_NAME})
elseif (WIN32)
    install(FILES ${cmake_files} DESTINATION cmake)
endif ()

########################################################################
# install include files
########################################################################
install(
    DIRECTORY spuce
    DESTINATION include
    COMPONENT spuce_dev
    FILES_MATCHING PATTERN "*.h"
)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

# only add uninstall if this is the main project  
if(${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
 add_custom_target(uninstall
   COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()


#########################################################################
# print features summary
#########################################################################
message(STATUS "######################################################")
message(STATUS "## Enabled features")
message(STATUS "######################################################")
feature_summary(WHAT ENABLED_FEATURES)
message(STATUS "######################################################")
message(STATUS "## Disabled features")
message(STATUS "######################################################")
feature_summary(WHAT DISABLED_FEATURES)

=== Makefile ===
build = build

all: $(build)/Makefile
	cd $(build) && make 

$(build)/Makefile: CMakeLists.txt
	mkdir -p $(build) && cd $(build) && cmake .. -DCMAKE_PREFIX_PATH=/usr/local/opt/qt5

clean:
	$(MAKE) -C $(build) clean
	rm -rf $(build)

=== qt_fir/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT("fir_plot")
Message("Project spuce fir_plot")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

FIND_PACKAGE(Qt5 REQUIRED Gui Core Widgets)

set(SOURCES
	make_filter.cpp 
	des_filter.cpp 
)

SET(fir_plot_SOURCES main.cpp mainwindow.cpp qcustomplot.cpp)
SET(fir_plot_HEADERS mainwindow.h other_freq.h qcustomplot.h)

INCLUDE_DIRECTORIES(${QT5_INCLUDES})
ADD_DEFINITIONS(${QT5Widgets_DEFINITIONS})

ADD_LIBRARY(spuce_fir STATIC ${SOURCES})
ADD_EXECUTABLE(spuce_fir_plot ${fir_plot_SOURCES} ${fir_plot_HEADERS_MOC})
set_property(TARGET spuce_fir PROPERTY CXX_STANDARD 11)

set_property(TARGET spuce_fir PROPERTY POSITION_INDEPENDENT_CODE TRUE)
set_property(TARGET spuce_fir_plot PROPERTY POSITION_INDEPENDENT_CODE TRUE)
set_property(TARGET spuce_fir_plot PROPERTY CXX_STANDARD 11)

TARGET_LINK_LIBRARIES(spuce_fir_plot spuce_fir ${QT_LIBRARIES} spuce)
QT5_USE_Modules(spuce_fir_plot Gui)
QT5_USE_Modules(spuce_fir_plot Core)
QT5_USE_Modules(spuce_fir_plot Widgets)
QT5_USE_Modules(spuce_fir_plot PrintSupport)

INSTALL(TARGETS spuce_fir_plot DESTINATION bin)

=== qt_iir/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT("iir_plot")
Message("Project spuce iir_plot")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

FIND_PACKAGE(Qt5 REQUIRED Gui Core Widgets)

set(SOURCES
	make_filter.cpp 	
	des_filter.cpp 
)

SET(iir_plot_SOURCES main.cpp mainwindow.cpp qcustomplot.cpp)
SET(iir_plot_HEADERS mainwindow.h qcustomplot.h)

INCLUDE_DIRECTORIES(${QT5_INCLUDES})
ADD_DEFINITIONS(${QT5Widgets_DEFINITIONS})

ADD_LIBRARY(spuce_iir STATIC ${SOURCES})
ADD_EXECUTABLE(spuce_iir_plot ${iir_plot_SOURCES} ${iir_plot_HEADERS_MOC})

set_property(TARGET spuce_iir PROPERTY CXX_STANDARD 11)
set_property(TARGET spuce_iir PROPERTY POSITION_INDEPENDENT_CODE TRUE)
set_property(TARGET spuce_iir_plot PROPERTY CXX_STANDARD 11)
set_property(TARGET spuce_iir_plot PROPERTY POSITION_INDEPENDENT_CODE TRUE)

TARGET_LINK_LIBRARIES(spuce_iir_plot spuce_iir ${QT_LIBRARIES} spuce)
QT5_USE_Modules(spuce_iir_plot Gui)
QT5_USE_Modules(spuce_iir_plot Core)
QT5_USE_Modules(spuce_iir_plot Widgets)
QT5_USE_Modules(spuce_iir_plot PrintSupport)

INSTALL(TARGETS spuce_iir_plot DESTINATION bin)

=== qt_other/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT("window_plot")
Message("Project spuce window_plot")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

FIND_PACKAGE(Qt5 REQUIRED Gui Core Widgets)

set(SOURCES	make_filter.cpp)
ADD_LIBRARY(spuce_other STATIC ${SOURCES})
set_property(TARGET spuce_other PROPERTY CXX_STANDARD 11)
set_property(TARGET spuce_other PROPERTY POSITION_INDEPENDENT_CODE TRUE)

SET(other_plot_SOURCES main.cpp mainwindow.cpp qcustomplot.cpp)
SET(other_plot_HEADERS mainwindow.h qcustomplot.h)

INCLUDE_DIRECTORIES(${QT5_INCLUDES})
ADD_DEFINITIONS(${QT5Widgets_DEFINITIONS})

ADD_EXECUTABLE(spuce_other_plot ${other_plot_SOURCES} ${other_plot_HEADERS_MOC})
set_property(TARGET spuce_other_plot PROPERTY CXX_STANDARD 11)
set_property(TARGET spuce_other_plot PROPERTY POSITION_INDEPENDENT_CODE TRUE)

TARGET_LINK_LIBRARIES(spuce_other_plot spuce_other ${QT_LIBRARIES} spuce)
QT5_USE_Modules(spuce_other_plot Gui)
QT5_USE_Modules(spuce_other_plot Core)
QT5_USE_Modules(spuce_other_plot Widgets)
QT5_USE_Modules(spuce_other_plot PrintSupport)

INSTALL(TARGETS spuce_other_plot DESTINATION bin)

=== qt_window/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT("window_plot")
Message("Project spuce window_plot")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

FIND_PACKAGE(Qt5 REQUIRED Gui Core Widgets)

set(SOURCES	make_filter.cpp)

SET(window_plot_SOURCES main.cpp mainwindow.cpp qcustomplot.cpp)
SET(window_plot_HEADERS mainwindow.h qcustomplot.h)

INCLUDE_DIRECTORIES(${QT5_INCLUDES})
ADD_DEFINITIONS(${QT5Widgets_DEFINITIONS})

ADD_LIBRARY(spuce_win STATIC ${SOURCES})
ADD_EXECUTABLE(spuce_window_plot ${window_plot_SOURCES} ${window_plot_HEADERS_MOC})

set_property(TARGET spuce_win PROPERTY CXX_STANDARD 11)
set_property(TARGET spuce_window_plot PROPERTY CXX_STANDARD 11)

set_property(TARGET spuce_win PROPERTY POSITION_INDEPENDENT_CODE TRUE)
set_property(TARGET spuce_window_plot PROPERTY POSITION_INDEPENDENT_CODE TRUE)

TARGET_LINK_LIBRARIES(spuce_window_plot spuce_win ${QT_LIBRARIES} spuce)
QT5_USE_Modules(spuce_window_plot Gui)
QT5_USE_Modules(spuce_window_plot Core)
QT5_USE_Modules(spuce_window_plot Widgets)
QT5_USE_Modules(spuce_window_plot PrintSupport)

INSTALL(TARGETS spuce_window_plot DESTINATION bin)

=== spuce/CMakeLists.txt ===
########################################################################
# Project setup
########################################################################
cmake_minimum_required(VERSION 2.8)

SET(FILT_SRCS  
	filters/butterworth_iir.cpp
	filters/chebyshev_iir.cpp
	filters/chebyshev2_iir.cpp
	filters/elliptic_iir.cpp
	filters/find_roots.cpp
	filters/fir_coeff.cpp
	filters/iir_coeff.cpp
  filters/design_iir.cpp
	# FIR stuff
  filters/design_fir.cpp
	filters/gaussian_fir.cpp
	filters/butterworth_fir.cpp
	filters/raised_cosine_imp.cpp
	filters/root_raised_cosine_imp.cpp
	filters/remez_estimate.cpp
	filters/remez_fir.cpp
	filters/sinc_fir.cpp
	filters/sinc_helper.cpp
	filters/create_remez_lpfir.cpp
	filters/fir_inv_dft.cpp
	filters/transform_fir.cpp
	# Windows
	filters/window.cpp
  filters/design_window.cpp
	# Other filters
	filters/butterworth_allpass.cpp
	filters/elliptic_allpass.cpp
  filters/shelf_allpass1.cpp
  filters/farrow_upsampler.cpp
  #
  filters/calculate_decimator_taps.cpp
)

add_library(spuce ${FILT_SRCS})
set_property(TARGET spuce PROPERTY CXX_STANDARD 11)
set_property(TARGET spuce PROPERTY POSITION_INDEPENDENT_CODE TRUE)

set_target_properties(spuce PROPERTIES SOVERSION ${SPUCE_SOVER})
set_target_properties(spuce PROPERTIES VERSION ${SPUCE_LIBVER})
set_target_properties(spuce PROPERTIES DEFINE_SYMBOL "SPUCE_DLL_EXPORTS")


install(TARGETS spuce
  LIBRARY DESTINATION lib${LIB_SUFFIX} # .so file
  ARCHIVE DESTINATION lib${LIB_SUFFIX} # .lib file
  RUNTIME DESTINATION bin              # .dll file
)

=== test_spuce/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

IF(NOT CMAKE_BUILD_TYPE)
	SET(CMAKE_BUILD_TYPE "DEBUG")
ENDIF()

PROJECT("spuce tests")
message("Project spuce_tests")

FIND_PACKAGE(PythonLibs REQUIRED)
include_directories(${PYTHON_INCLUDE_DIRS})

add_library(spuce_debug plot_fft.cpp cfft.cpp gen_iir_df)
set_property(TARGET spuce_debug PROPERTY CXX_STANDARD 11)
set_property(TARGET spuce_debug PROPERTY POSITION_INDEPENDENT_CODE TRUE)

SET(PLOT_TARGETS
	chebyshev_iir chebyshev_iir_hpf
	chebyshev2_iir chebyshev2_iir_hpf
	elliptic_iir elliptic_iir_hpf
	butterworth_iir butterworth_iir_hpf
	butterworth_iir_bp butterworth_iir_bs
	elliptic_iir_bp iir iir_df iir_df2
  # fir
  fir maxflat remez kaiser sinc
  # window
  window
  # FIR bandpass/stop
  rc_bsf
	transform_bpf	transform_hpf transform_bsf
	transform_complex_bpf	transform_complex_bsf
  sinc_bsf
	# special filters
	iir_allpass1
	notch
  cic
  interp
  # other
  decimate
  decimate2
	)

FOREACH(mod ${PLOT_TARGETS})
	SET(SRC test_${mod}.cpp)
	ADD_EXECUTABLE(spuce_plot_${mod} ${SRC})
  TARGET_LINK_LIBRARIES(spuce_plot_${mod} spuce spuce_debug ${PYTHON_LIBRARY})
	set_property(TARGET spuce_plot_${mod} PROPERTY CXX_STANDARD 11)
	set_property(TARGET spuce_plot_${mod} PROPERTY POSITION_INDEPENDENT_CODE TRUE)
ENDFOREACH(mod ${EXTS})

SET(UNIT_TARGETS
  remez_estimate
	)

FOREACH(mod ${UNIT_TARGETS})
	SET(SRC test_${mod}.cpp)
	ADD_EXECUTABLE(spuce_${mod} ${SRC})
  TARGET_LINK_LIBRARIES(spuce_${mod} spuce spuce_debug ${PYTHON_LIBRARY})
	set_property(TARGET spuce_${mod} PROPERTY CXX_STANDARD 11)
	set_property(TARGET spuce_${mod} PROPERTY POSITION_INDEPENDENT_CODE TRUE)
ENDFOREACH(mod ${EXTS})

=== debian/changelog ===
spuce (0.4.3-myriadrf1~wily) wily; urgency=low

  * Release 0.4.3 (2015-12-19)

 -- Tony Kirke <tony@pyspuc.com>  Sat, 19 Dec 2015 12:22:00 -0700

spuce (0.4.2-myriadrf1~wily) wily; urgency=low

  * Release 0.4.2 (2015-12-11)

 -- Tony Kirke <tony@pyspuc.com>  Fri, 11 Dec 2015 15:35:00 -0700

spuce (0.4.1-ppa1-jessie64) unstable; urgency=low

  * Release 0.4.1 (2015-11-22)

 -- Tony Kirke <tony@pyspuc.com>  Sun, 22 Nov 2015 11:25:09 -0700

=== debian/control ===
Source: spuce
Section: comm
Priority: optional
Maintainer: Tony Kirke <tony@pyspuc.com>
Build-Depends:
    debhelper (>= 9.0.0),
    cmake (>= 2.8.7),
    qtbase5-dev,
Standards-Version: 3.9.6
Homepage: https://github.com/audiofilter/spuce/wiki
Vcs-Git: https://github.com/audiofilter/spuce.git
Vcs-Browser: https://github.com/audiofilter/spuce

Package: libspuce0.4-3
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: multiarch-support, ${misc:Pre-Depends}
Depends:
     ${shlibs:Depends},
     ${misc:Depends}
Description: Spuce - shared library
 A DSP filtering library.

Package: libspuce-dev
Section: libdevel
Architecture: any
Depends:
    libspuce0.4-3 (= ${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Description: Spuce - development files
 A DSP filtering library.

Package: spuce
Section: science
Architecture: any
Depends:
    libspuce0.4-3 (= ${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Description: Example applications for libspuce
 A DSP filtering library.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# extract the architecture for setting the library path suffix
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# extract the last section of the changelog version for extra info
DEB_VERSION_EXTVER ?= $(shell dpkg-parsechangelog | grep ^Version: | rev | cut -d'-' -f1 | rev)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS


%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DBUILD_SHARED_LIBS=ON \
		-DENABLE_PYTHON=OFF \
		-DSPUCE_EXTVER="$(DEB_VERSION_EXTVER)"
